execute as @s at @s unless score @s Capacitor_Charge matches 0.. run scoreboard players set @s Capacitor_Charge 0
execute as @s at @s if score @s Capacitor_Charge matches 1201.. run scoreboard players set @s Capacitor_Charge 1200

# Determining number of inputs and outputs
execute as @s at @s run scoreboard players reset @s input_count
execute as @s at @s run scoreboard players reset @s output_count
execute as @s at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=1},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=2},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=3},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=4},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=5},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=6},distance=...001] run scoreboard players add @s input_count 1

execute as @s at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=1},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=2},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=3},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=4},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=5},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=6},distance=...001] run scoreboard players add @s output_count 1

# Changing power state
execute as @s at @s if score @s Capacitor_Charge >= @s output_count if score @s input_count matches 1.. unless predicate copperwire:function_block_lever run scoreboard players set @s powered_state 1
execute as @s at @s if score @s Capacitor_Charge >= @s output_count unless score @s input_count matches 1.. run scoreboard players set @s powered_state 1
execute as @s at @s if score @s input_count >= @s output_count unless score @s Capacitor_Charge matches 1200.. unless predicate copperwire:function_block_lever run scoreboard players set @s powered_state 1
execute as @s at @s if score @s input_count >= @s output_count if score @s Capacitor_Charge matches 1200.. run scoreboard players set @s powered_state 1

execute as @s at @s unless score @s Capacitor_Charge >= @s output_count unless score @s input_count >= @s output_count run scoreboard players set @s powered_state 0
execute as @s if predicate copperwire:function_block_lever if score @s input_count matches 1.. unless score @s Capacitor_Charge matches 1200.. run scoreboard players set @s powered_state 0

# Capacitor-Specific stuff
execute as @s at @s if score @s Capacitor_Charge matches ..1200 run scoreboard players operation @s Capacitor_Charge += @s input_count
execute as @s[scores={powered_state=1}] at @s if score @s Capacitor_Charge >= @s output_count run scoreboard players operation @s Capacitor_Charge -= @s output_count
execute as @s at @s if score @s Capacitor_Charge matches ..1200 unless block ~ ~ ~ #copperwire:no_oxidation run scoreboard players operation @s Capacitor_Charge += @s input_count
execute as @s[scores={powered_state=1}] at @s if score @s Capacitor_Charge >= @s output_count unless block ~ ~ ~ #copperwire:no_oxidation run scoreboard players operation @s Capacitor_Charge -= @s output_count
execute as @s at @s if score @s Capacitor_Charge matches ..1200 unless block ~ ~ ~ #copperwire:no_oxidation unless block ~ ~ ~ #copperwire:exposed run scoreboard players operation @s Capacitor_Charge += @s input_count
execute as @s[scores={powered_state=1}] at @s if score @s Capacitor_Charge >= @s output_count unless block ~ ~ ~ #copperwire:no_oxidation unless block ~ ~ ~ #copperwire:exposed run scoreboard players operation @s Capacitor_Charge -= @s output_count
execute as @s at @s if score @s Capacitor_Charge matches ..1200 if block ~ ~ ~ #copperwire:oxidized run scoreboard players operation @s Capacitor_Charge += @s input_count
execute as @s[scores={powered_state=1}] at @s if score @s Capacitor_Charge >= @s output_count if block ~ ~ ~ #copperwire:oxidized run scoreboard players operation @s Capacitor_Charge -= @s output_count

execute as @s at @s if score @s Capacitor_Charge < @s output_count run data modify entity @s block_state.Name set value "minecraft:air"
execute as @s at @s if score @s Capacitor_Charge matches 1..1200 unless score @s Capacitor_Charge < @s output_count run data modify entity @s block_state.Name set value "minecraft:lime_concrete"
execute as @s at @s if score @s Capacitor_Charge matches 1..1200 store result entity @s transformation.scale[1] float 0.00078125 run scoreboard players get @s Capacitor_Charge

# Wires power off
execute as @s[scores={powered_state=0}] at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=1},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=2},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=3},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=4},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=5},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=6},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0


# Wires power on
execute as @s[scores={powered_state=1}] at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=1},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=2},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=3},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=4},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=5},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=6},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1

# Wires power on
execute as @s[scores={powered_state=1}] at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=1},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=2},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=3},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=4},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=5},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=6},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1