# Determining number of inputs and outputs
execute as @s at @s run scoreboard players reset @s input_count
execute as @s at @s run scoreboard players reset @s output_count
execute as @s at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=1},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=2},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=3},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=4},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=5},distance=...001] run scoreboard players add @s input_count 1
execute as @s at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=6},distance=...001] run scoreboard players add @s input_count 1

execute as @s at @s unless predicate copperwire:function_block_lever positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=1},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s unless predicate copperwire:function_block_lever positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=2},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s unless predicate copperwire:function_block_lever positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=3},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s unless predicate copperwire:function_block_lever positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=4},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s unless predicate copperwire:function_block_lever positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=5},distance=...001] run scoreboard players add @s output_count 1
execute as @s at @s unless predicate copperwire:function_block_lever positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={directional_wire=6},distance=...001] run scoreboard players add @s output_count 1

execute as @s at @s if block ~ ~ ~ #copperwire:exposed run scoreboard players add @s output_count 1
execute as @s at @s if block ~ ~ ~ #copperwire:weathered run scoreboard players add @s output_count 2
execute as @s at @s if block ~ ~ ~ #copperwire:oxidized run scoreboard players add @s output_count 3

# Changing power state
execute as @s if score @s input_count = @s output_count unless predicate copperwire:function_block_lever run scoreboard players set @s powered_state 1
execute as @s unless score @s input_count = @s output_count run scoreboard players set @s powered_state 0
execute as @s if predicate copperwire:function_block_lever run scoreboard players set @s powered_state 0

# Wires power off
execute as @s[scores={powered_state=0}] at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=1},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=2},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=3},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=4},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=5},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0
execute as @s[scores={powered_state=0}] at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,directional_wire=6},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},distance=...001] powered_state 0

# Wires power on
execute as @s[scores={powered_state=1}] at @s positioned ~1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=1},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~-1 ~ ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=2},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~ ~1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=3},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~ ~-1 if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=4},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=5},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1
execute as @s[scores={powered_state=1}] at @s positioned ~ ~-1 ~ if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0,directional_wire=6},distance=...001] run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=...001] powered_state 1