# Allowing lightning bolts to power wires
execute as @e[type=lightning_bolt] at @s positioned ~ ~-1 ~ if block ~ ~ ~ lightning_rod align xyz unless entity @e[type=marker,tag=wire,distance=...001] run summon marker ~.5 ~.5 ~.5 {Tags:["wire","copper_wiring"]}
execute as @e[type=lightning_bolt] at @s if block ~ ~ ~ lightning_rod align xyz unless entity @e[type=marker,tag=wire,distance=...001] run summon marker ~.5 ~.5 ~.5 {Tags:["wire","copper_wiring"]}

# Looking at activation, deactivation, and alignment
execute as @a anchored eyes at @s positioned ^ ^ ^1 if block ~ ~ ~ lightning_rod run function copperwire:summon/looking
execute as @a anchored eyes at @s positioned ^ ^ ^2 if block ~ ~ ~ lightning_rod run function copperwire:summon/looking
execute as @a anchored eyes at @s positioned ^ ^ ^3 if block ~ ~ ~ lightning_rod run function copperwire:summon/looking
execute as @a anchored eyes at @s positioned ^ ^ ^4 if block ~ ~ ~ lightning_rod run function copperwire:summon/looking

# Kill commands
execute as @e[type=marker,tag=passthrough_wire_block] at @s unless block ~ ~ ~ #copperwire:chiseled_copper run kill @s
execute as @e[type=marker,tag=split_wire_block] at @s unless block ~ ~ ~ #copperwire:copper_block run kill @s
execute as @e[type=block_display,tag=capacitor_wire_block] at @s unless block ~ ~ ~ #copperwire:copper_grate run kill @s
execute as @e[type=marker,tag=cut_wire_block] at @s unless block ~ ~ ~ #copperwire:cut_copper run kill @s
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless block ~ ~ ~ lightning_rod if score @s Capacitor_Charge matches 0 run kill @s
execute as @e[type=block_display,tag=wire_insulation] at @s unless block ~ ~ ~ lightning_rod run function copperwire:wire_insulation_kill

# Non-looking at activations
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if block ~ ~ ~ lightning_rod if entity @e[type=item,distance=...5,tag=!insulator] unless entity @e[type=block_display,tag=wire_insulation,distance=...01] run function copperwire:summon/wire_insulation
execute as @e[type=marker,tag=copper_wiring] at @s if block ~ ~ ~ #copperwire:all_copper run function copperwire:summon/block


execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,Capacitor_Charge=..3}] at @s if block ^ ^ ^1 #copperwire:chiseled_copper run scoreboard players add @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={Capacitor_Charge=1..4}] at @s unless block ^ ^ ^1 #copperwire:chiseled_copper run scoreboard players set @s Capacitor_Charge 0
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless score @s powered_state matches 1 if score @s Capacitor_Charge matches 1.. run scoreboard players remove @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless score @s Capacitor_Charge matches 0..4 run scoreboard players set @s Capacitor_Charge 0
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless block ~ ~ ~ lightning_rod run scoreboard players set @s powered_state 0


# Block functions
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless predicate copperwire:wire_scores run function copperwire:directional_wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score wire_speed wire_speed matches 1 if block ~ ~ ~ lightning_rod positioned ^ ^ ^1 unless entity @e[type=marker,tag=copper_wiring,distance=...01] run function copperwire:summon/wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score wire_speed wire_speed matches 1 if block ~ ~ ~ lightning_rod positioned ^ ^ ^-1 if block ~ ~ ~ lightning_rod unless score @s powered_state = @n[tag=copper_wiring,tag=wire,distance=...001] powered_state if score @s directional_wire = @n[tag=copper_wiring,tag=wire,distance=...001] directional_wire run function copperwire:wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score wire_speed wire_speed matches 0 if block ~ ~ ~ lightning_rod positioned ^ ^ ^1 unless entity @e[type=marker,tag=copper_wiring,distance=...01] run function copperwire:summon/wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score wire_speed wire_speed matches 0 if block ~ ~ ~ lightning_rod positioned ^ ^ ^-1 if block ~ ~ ~ lightning_rod if score @s directional_wire = @n[tag=copper_wiring,tag=wire,distance=...001] directional_wire run function copperwire:wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if block ~ ~ ~ lightning_rod positioned ^ ^ ^-1 if block ~ ~ ~ #copperwire:all_copper run function copperwire:wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if block ~ ~ ~ lightning_rod unless block ^ ^ ^-1 lightning_rod unless block ^ ^ ^-1 #copperwire:all_copper run function copperwire:wire
execute as @e[type=marker,tag=split_wire_block] at @s if block ~ ~ ~ #copperwire:copper_block run function copperwire:split_wire
execute as @e[type=marker,tag=cut_wire_block] at @s if block ~ ~ ~ #copperwire:cut_copper run function copperwire:cut_wire
execute as @e[type=marker,tag=passthrough_wire_block] at @s if block ~ ~ ~ #copperwire:chiseled_copper run function copperwire:passthrough_wire
execute as @e[type=block_display,tag=capacitor_wire_block] at @s if block ~ ~ ~ #copperwire:copper_grate run function copperwire:capacitor_wire

# Damaging players/mobs from shock damage and particles
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1}] at @s if block ~ ~ ~ lightning_rod[waterlogged=true] unless entity @e[type=block_display,tag=wire_insulation,distance=...01] run execute as @e[type=!marker,type=!item,distance=..1.575] at @s if predicate copperwire:waterlogged run damage @s 1 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1}] at @s if block ~ ~ ~ lightning_rod[waterlogged=true] if entity @e[type=block_display,tag=wire_insulation,distance=...01] positioned ^ ^ ^1 run execute as @e[type=!marker,type=!item,distance=...575] at @s if predicate copperwire:waterlogged run damage @s 1 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1}] at @s unless entity @e[type=block_display,tag=wire_insulation,distance=...01] run execute as @e[type=!marker,type=!item,distance=...75] at @s run damage @s 1 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1}] at @s positioned ^ ^ ^.55 if block ~ ~ ~ air run execute as @e[type=!marker,type=!item,distance=...6] at @s run damage @s 1 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1}] at @s positioned ^ ^ ^.55 if block ~ ~ ~ #copperwire:no_fill_insulation_blocks run particle electric_spark ^ ^ ^.05 0.01 0.01 0.01 .25 3

# Wire insulation scaling and positioning based on blocks around
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.4375f],scale:[.375f,.375f,.875f]}}] at @s if block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks if block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.4375f],scale:[.375f,.375f,.875f]}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.4374f],scale:[.375f,.375f,.9377f]}}] at @s if block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks unless block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.4374f],scale:[.375f,.375f,.9377f]}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,.9375f]}}] at @s unless block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks if block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,.9375f]}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,1.0002f]}}] at @s unless block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks unless block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,1.0002f]}}